## Qdu service Qdu service — Support for the Qdu service. |

## Functions

MbimMessage * | mbim_message_qdu_update_session_query_new ()
MbimMessage * | mbim_message_qdu_update_session_set_new ()
gboolean | mbim_message_qdu_update_session_response_parse ()
MbimMessage * | mbim_message_qdu_file_open_query_new ()
MbimMessage * | mbim_message_qdu_file_open_set_new ()
gboolean | mbim_message_qdu_file_open_response_parse ()
MbimMessage * | mbim_message_qdu_file_write_set_new ()
gboolean | mbim_message_qdu_file_write_response_parse ()

## Description

This section implements support for requests, responses and notifications in the Qdu service.

## Functions

### mbim_message_qdu_update_session_query_new ()

    MbimMessage *
    mbim_message_qdu_update_session_query_new
                                   (GError **error);

Create a new request for the 'Update Session' query command in the 'QDU' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_qdu_update_session_set_new ()

    MbimMessage *
    mbim_message_qdu_update_session_set_new
                                   (MbimQduSessionAction session_action,
                                    MbimQduSessionType session_type,
                                    GError **error);

Create a new request for the 'Update Session' set command in the 'QDU' service.

#### Parameters

session_action | the 'SessionAction' field, given as a MbimQduSessionAction. | [in]
session_type | the 'SessionType' field, given as a MbimQduSessionType. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_qdu_update_session_response_parse ()

    gboolean
    mbim_message_qdu_update_session_response_parse
                                   (const MbimMessage *message,
                                    MbimQduSessionType *out_current_session_type,
                                    MbimQduSessionStatus *out_current_session_status,
                                    MbimQduSessionType *out_last_session_type,
                                    MbimQduSessionResult *out_last_session_result,
                                    guint32 *out_last_session_error_offset,
                                    guint32 *out_last_session_error_size,
                                    GError **error);

Parses and returns parameters of the 'Update Session' response command in the 'QDU' service.

#### Parameters

message | the MbimMessage. |
out_current_session_type | return location for a MbimQduSessionType, or `NULL` if the 'CurrentSessionType' field is not needed. | [out][optional][transfer none]
out_current_session_status | return location for a MbimQduSessionStatus, or `NULL` if the 'CurrentSessionStatus' field is not needed. | [out][optional][transfer none]
out_last_session_type | return location for a MbimQduSessionType, or `NULL` if the 'LastSessionType' field is not needed. | [out][optional][transfer none]
out_last_session_result | return location for a MbimQduSessionResult, or `NULL` if the 'LastSessionResult' field is not needed. | [out][optional][transfer none]
out_last_session_error_offset | return location for a guint32, or `NULL` if the 'LastSessionErrorOffset' field is not needed. | [out][optional][transfer none]
out_last_session_error_size | return location for a guint32, or `NULL` if the 'LastSessionErrorSize' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_qdu_file_open_query_new ()

    MbimMessage *
    mbim_message_qdu_file_open_query_new (GError **error);

Create a new request for the 'File Open' query command in the 'QDU' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_qdu_file_open_set_new ()

    MbimMessage *
    mbim_message_qdu_file_open_set_new (MbimQduFileType file_type,
                                        guint32 file_size,
                                        GError **error);

Create a new request for the 'File Open' set command in the 'QDU' service.

#### Parameters

file_type | the 'FileType' field, given as a MbimQduFileType. | [in]
file_size | the 'FileSize' field, given as a guint32. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_qdu_file_open_response_parse ()

    gboolean
    mbim_message_qdu_file_open_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_max_transfer_size,
                                    guint32 *out_max_window_size,
                                    GError **error);

Parses and returns parameters of the 'File Open' response command in the 'QDU' service.

#### Parameters

message | the MbimMessage. |
out_max_transfer_size | return location for a guint32, or `NULL` if the 'MaxTransferSize' field is not needed. | [out][optional][transfer none]
out_max_window_size | return location for a guint32, or `NULL` if the 'MaxWindowSize' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_qdu_file_write_set_new ()

    MbimMessage *
    mbim_message_qdu_file_write_set_new (const guint32 data_buffer_size,
                                         const guint8 *data_buffer,
                                         GError **error);

Create a new request for the 'File Write' set command in the 'QDU' service.

#### Parameters

data_buffer_size | size of the data_buffer array. | [in]
data_buffer | the 'DataBuffer' field, given as an array of guint8 values. | [in][element-type guint8][array length=data_buffer_size]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_qdu_file_write_response_parse ()

    gboolean
    mbim_message_qdu_file_write_response_parse
                                   (const MbimMessage *message,
                                    GError **error);

Parses and returns parameters of the 'File Write' response command in the 'QDU' service.

#### Parameters

message | the MbimMessage. |
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26